/*
 * Progetto 2 del Capitolo 6 del libro Savitch.
 * 
 * Scrivere un programma che legge una riga di testo che termina
 * con un punto, che funge da valore sentinella.
 * Visualizzare tutte le lettere presenti nel testo, una per riga
 * e in ordine alfabetico, indicando il numero di volte che si
 * presenta nel testo.
 * Utilizzare un array di tipo base int di lunghezza 21 (questa
 * versione usa un vettore di 26 caratteri per includere anche le
 * lettere j, k, w, x, y - attenzione perch non vengono gestite
 * le lettere accentate), cos che l'elemento all'indice 0
 * contenga il numero di lettere "a", l'elemento all'indice 1
 * contenda il numero di lettere "b", e cos via.
 * Considerare come input sia le lettere maiuscole, sia quelle 
 * minuscole, ma poi, nel conteggio, considerarle uguali.
 * Suggerimento: prima di elaborare la riga di testo, utilizzare
 * uno dei metodi toUpperCase o toLowerCase della classe String.
 * Potrebbe essere utile definire un metodo che prende come 
 * argomento un carattere e restituisce un valore int che 
 * corrisponde al corretto indice di quel carattere. 
 * Per esempio, l'argomento 'a' restituir 0, l'argomento 'b'
 * restituir 1, e cos via.
 * Si noti che  possibile utilizzare una conversione di tipo,
 * come (int)lettera, per trasformare un char in int.
 * Sicuramente questo non restituir il valore desiderato, ma se
 * si sottrae (int)'a', si avr l'indice corretto.
 * Infine si permetta all'utente di ripetere queste operazioni
 * finch vuole. 
 * 
 */

import java.util.*;

public class OccorrenzeDiLettere {
	
	public static final int NUMERO_LETTERE = 26;
	
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		
		boolean finito = false;
		do{
			System.out.println("Inserire la riga di testo: ");
			String testo = tastiera.nextLine().toLowerCase();

			int[] occorrenze = new int[NUMERO_LETTERE];
		
			for(int i=0; i<testo.length(); i++){
				int indiceLettera = converti(testo.charAt(i));
				if(indiceLettera >= 0 && indiceLettera <NUMERO_LETTERE)
					occorrenze[indiceLettera]++;
			}
		
			visualizza(occorrenze);
			
			System.out.println("Vuoi proseguire (s/n)?");
			if(tastiera.next().equalsIgnoreCase("n"))
				finito=true;
			else
				tastiera.nextLine();
		}while(!finito);
		
		tastiera.close();
	}
	
	public static int converti(char lettera){
		return (int)lettera - (int)'a';
	}
	
	public static void visualizza(int[] v){
		for(int i=0;i<v.length;i++)
			System.out.println("Lettera "+(char)((int)'a'+i)+": "+v[i]);
	}

}
